%global pkg megaraid_mbox

%global kernel_version 4.18.0-338.el8

%global _use_internal_dependency_generator 0
%global __find_requires %{nil}
%global __find_provides /usr/lib/rpm/find-provides

%global debug_package %{nil}

%global __spec_install_post \
  %{?__debug_package:%{__debug_install_post}} \
  %{__arch_install_post} \
  %{__os_install_post} \
  %{__mod_compress_install_post}

%global __mod_compress_install_post find %{buildroot}/lib/modules -type f -name \*.ko -exec xz \{\} \\;


Name:             kmod-%{pkg}
Version:          4.18
Release:          4%{?dist}
Summary:          LSI Logic MegaRAID (%{pkg}) driver

License:          GPLv2
URL:              https://www.kernel.org/

Source0:          %{pkg}-%{version}.tar.xz

ExclusiveArch:    x86_64 aarch64

BuildRequires:    elfutils-libelf-devel
BuildRequires:    gcc
BuildRequires:    kmod
BuildRequires:    make
BuildRequires:    redhat-rpm-config
BuildRequires:    xz

BuildRequires:    kernel-devel = %{kernel_version}
BuildRequires:    kernel-devel-uname-r = %{kernel_version}.%{_arch}

Requires:         kernel-core = %{kernel_version}
Requires:         kernel-core-uname-r = %{kernel_version}.%{_arch}
Requires:         kernel-modules = %{kernel_version}
Requires:         kernel-modules-uname-r = %{kernel_version}.%{_arch}

Provides:         installonlypkg(kernel-module)
Provides:         kernel-modules = %{kernel_version}.%{_arch}
Provides:         %{name}-%{kernel_version}.%{_arch} = %{?epoch:%{epoch}:}%{version}-%{release}

Requires(post):   /usr/sbin/depmod
Requires(postun): /usr/sbin/depmod

Requires(post):   /usr/bin/dracut
Requires(postun): /usr/bin/dracut

Provides:         kmod-megaraid_mm = %{?epoch:%{epoch}:}%{version}-%{release}
Provides:         kmod-megaraid_mm-%{kernel_version}.%{_arch} = %{?epoch:%{epoch}:}%{version}-%{release}


%description
This package provides the LSI Logic MegaRAID (%{pkg}) driver including the
required LSI Logic Management Module (megaraid_mm) driver. Supported devices:

- 0x1000:0407:1000:0530: LSI MegaRAID SCSI 320-0X
- 0x1000:0407:1000:0531: LSI MegaRAID SCSI 320-4X
- 0x1000:0407:1000:0532: LSI MegaRAID SCSI 320-2X
- 0x1000:0407:1028:0531: Dell PERC4/QC
- 0x1000:0407:8086:0530: Intel RAID Controller SRCZCRX
- 0x1000:0407:8086:0532: Intel RAID Controller SRCU42X
- 0x1000:0408:1000:0001: LSI MegaRAID SCSI 320-1E
- 0x1000:0408:1000:0002: LSI MegaRAID SCSI 320-2E
- 0x1000:0408:1025:004D: ACER MegaRAID ROMB-2E
- 0x1000:0408:1028:0001: Dell PERC 4e/SC
- 0x1000:0408:1028:0002: Dell PERC 4e/DC
- 0x1000:0408:1033:8287: NEC MegaRAID PCI Express ROMB
- 0x1000:0408:1734:1065: FSC MegaRAID PCI Express ROMB
- 0x1000:0408:8086:0002: Intel RAID Controller SRCU42E
- 0x1000:0408:8086:3431: Intel RAID Controller SROMBU42E
- 0x1000:0408:8086:3499: Intel RAID Controller SROMBU42E
- 0x1000:0409:1000:3004: LSI MegaRAID SATA 300-4X
- 0x1000:0409:1000:3008: LSI MegaRAID SATA 300-8X
- 0x1000:0409:8086:3008: Intel RAID Controller SRCS28X
- 0x1000:1960:1000:0518: LSI MegaRAID SCSI 320-2
- 0x1000:1960:1000:0520: LSI MegaRAID SCSI 320-1
- 0x1000:1960:1000:0523: LSI MegaRAID SATA 150-6
- 0x1000:1960:1000:4523: LSI MegaRAID SATA 150-4
- 0x1000:1960:1000:A520: LSI MegaRAID SCSI 320-0
- 0x1000:1960:1028:0518: Dell PERC4/DC
- 0x1000:1960:1028:0520: Dell PERC4/SC
- 0x1000:1960:8086:0520: Intel RAID Controller SRCU51L
- 0x1000:1960:8086:0523: Intel RAID Controller SRCS16
- 0x101E:1960:1028:0471: Dell PERC3/QC
- 0x101E:1960:1028:0475: Dell PERC3/SC
- 0x101E:1960:1028:0493: Dell PERC3/DC
- 0x1028:000E:1028:0123: Dell PERC3/Di
- 0x1028:000F:1028:014A: Dell PERC4/Di
- 0x1028:0013:1028:016C: Dell PERC 4e/Si
- 0x1028:0013:1028:016D: Dell PERC 4e/Di
- 0x1028:0013:1028:016E: Dell PERC 4e/Di
- 0x1028:0013:1028:016F: Dell PERC 4e/Di
- 0x1028:0013:1028:0170: Dell PERC 4e/Di


%prep
%autosetup -p1 -n %{pkg}-%{version}


%build
pushd src
%{__make} -C /usr/src/kernels/%{kernel_version}.%{_arch} %{?_smp_mflags} M=$PWD modules
popd


%install
%{__install} -D -t %{buildroot}/lib/modules/%{kernel_version}.%{_arch}/extra/drivers/scsi/megaraid src/%{pkg}.ko src/megaraid_mm.ko
%{__install} -d %{buildroot}/%{_sysconfdir}/dracut.conf.d/
echo "add_drivers+=\" %{pkg} \"" > %{buildroot}/%{_sysconfdir}/dracut.conf.d/%{pkg}.conf

# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+


%clean
%{__rm} -rf %{buildroot}


%post
mkdir -p %{_localstatedir}/lib/rpm-state/sig-kmods
touch %{_localstatedir}/lib/rpm-state/sig-kmods/%{kernel_version}.%{_arch}


%preun
mkdir -p %{_localstatedir}/lib/rpm-state/sig-kmods
touch %{_localstatedir}/lib/rpm-state/sig-kmods/%{kernel_version}.%{_arch}


%postun
if [ -f %{_localstatedir}/lib/rpm-state/sig-kmods/%{kernel_version}.%{_arch} ]
then
    if [ -f /lib/modules/%{kernel_version}.%{_arch}/System.map ]
    then
        /usr/sbin/depmod -aeF /lib/modules/%{kernel_version}.%{_arch}/System.map %{kernel_version}.%{_arch}
    fi

    if [ -f /boot/initramfs-%{kernel_version}.%{_arch}.img ]
    then
        if /usr/bin/dracut -f --rebuild /boot/initramfs-%{kernel_version}.%{_arch}.img /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew %{kernel_version}.%{_arch}
        then
            if ! cmp -s /boot/initramfs-%{kernel_version}.%{_arch}.img /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew
            then
                mv /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew /boot/initramfs-%{kernel_version}.%{_arch}.img
            else
                rm -f /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew
            fi
        fi
    fi

    rm -f %{_localstatedir}/lib/rpm-state/sig-kmods/%{kernel_version}.%{_arch}
    rmdir --ignore-fail-on-non-empty %{_localstatedir}/lib/rpm-state/sig-kmods
fi


%posttrans
if [ -f %{_localstatedir}/lib/rpm-state/sig-kmods/%{kernel_version}.%{_arch} ]
then
    if [ -f /lib/modules/%{kernel_version}.%{_arch}/System.map ]
    then
        /usr/sbin/depmod -aeF /lib/modules/%{kernel_version}.%{_arch}/System.map %{kernel_version}.%{_arch}
    fi

    if [ -f /boot/initramfs-%{kernel_version}.%{_arch}.img ]
    then
        if /usr/bin/dracut -f --rebuild /boot/initramfs-%{kernel_version}.%{_arch}.img /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew %{kernel_version}.%{_arch}
        then
            if ! cmp -s /boot/initramfs-%{kernel_version}.%{_arch}.img /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew
            then
                mv /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew /boot/initramfs-%{kernel_version}.%{_arch}.img
            else
                rm -f /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew
            fi
        fi
    fi

    rm -f %{_localstatedir}/lib/rpm-state/sig-kmods/%{kernel_version}.%{_arch}
    rmdir --ignore-fail-on-non-empty %{_localstatedir}/lib/rpm-state/sig-kmods
fi


%files
%defattr(644,root,root,755)
/lib/modules/%{kernel_version}.%{_arch}
%license COPYING
%config(noreplace) %{_sysconfdir}/dracut.conf.d/%{pkg}.conf


%changelog
* Mon Aug 30 2021 Peter Georg <peter.georg@physik.uni-regensburg.de> - 4.18-4
- Set specific kernel version to use
- Add Provides kernel-modules
- Add .%{_arch} to kernel-modules provides version
- Rebuild for 4.18.0-338.el8

* Thu Aug 19 2021 Peter Georg <peter.georg@physik.uni-regensburg.de> - 4.18-3
- Rebuild for 4.18.0-331.el8

* Wed Aug 11 2021 Peter Georg <peter.georg@physik.uni-regensburg.de> - 4.18-2
- Rebuild for 4.18.0-326.el8

* Mon Aug  9 2021 Peter Georg <peter.georg@physik.uni-regensburg.de> - 4.18-1
- Initial version
